/**
  The BasicMesh is the base for all mesh. I will create two meshes:
    BSMeshX  - loading from a .x file
	BSMyMesh - loading from my own file type
*/
#ifndef _BSBASICMESH
#define _BSBASICMESH
#include "bsscenenod.h"

class BSBasicMesh : public BSSceneNod {
	protected:
		LPD3DXMESH mesh; //DirectX Mesh Object
		LPD3DXBUFFER mat; //DirectX Mesh Material Buffer
		LPDIRECT3DTEXTURE9* tex; //DirectX Textures
		DWORD numMat; //number of subsets and materials
	public:
		BSBasicMesh(BSScene* s, BSSceneObject* obj) : BSSceneNod(s, obj) { }; //basic creator
		~BSBasicMesh(); //basic destroyer

		LPD3DXMESH getMesh() { return mesh; }

		void Release();
};
#endif