#include "bssceneobject.h"

/******************** MATRIXES *******************/

D3DXMATRIX BSSceneObject::matrixPos() { 
	D3DXMatrixTranslation(&m_position, pos.x, pos.y, pos.z); 
	return m_position;
}; //create the Translation Matrix

D3DXMATRIX BSSceneObject::matrixRotationX() {
	D3DXMatrixRotationX(&m_rotX, BSToRadian(getAngleX())); 
	return m_rotX; 
}; //create the RotationX Matrix

D3DXMATRIX BSSceneObject::matrixRotationY() {
	D3DXMatrixRotationY(&m_rotY, BSToRadian(getAngleY()));
	return m_rotY;
}; //create the RotationX Matrix

D3DXMATRIX BSSceneObject::matrixRotationZ() {
	D3DXMatrixRotationZ(&m_rotZ, BSToRadian(getAngleZ())); 
	return m_rotZ;
}; //create the RotationX Matrix

D3DXMATRIX BSSceneObject::matrixScale() {
	D3DXMatrixScaling(&m_scale, scale.x, scale.y, scale.z);
	return m_scale;
}; //create scale matrix



/******************** MATRIXES GROUPS *******************/


//can improve performace by only creating matrixes when something has changed
D3DXMATRIX BSSceneObject::matrixRotation() { 
	return (matrixRotationX() * matrixRotationY() * matrixRotationZ());
} //create a matrix with all rotation values

D3DXMATRIX BSSceneObject::matrixTransform() {
	//first check if there is any parent
	if (parent != NULL) {
		//if yes draw first the object properties and then the parent properties
		return (matrixRotation() * matrixScale() * matrixPos() * parent->matrixTransform());
	} else {
		//no parent? just the object properties
		return (matrixRotation() * matrixScale() * matrixPos());
	}
}; //create the Transform matrix
