#include "bsfont.h"

/************** CONSTRUCTOR ***************/

BSFont::BSFont(BSGUI* dev, BSGUIObject* obj, LONG size, string fontname) : BSGUIObject(dev, obj) {
    LogFont.Height = size;

	//defining the default properties
    LogFont.Width = 0;
    LogFont.MipLevels = 1;
    LogFont.Weight = FW_NORMAL;
    LogFont.Italic = FALSE;
    LogFont.CharSet = DEFAULT_CHARSET;
    LogFont.OutputPrecision = OUT_DEFAULT_PRECIS;
    LogFont.Quality =DEFAULT_QUALITY;
    LogFont.PitchAndFamily =DEFAULT_PITCH | FF_DONTCARE;

	//define the font name
	if (fontname.size() < 32)
		strcpy_s(LogFont.FaceName, fontname.c_str());
		

	D3DXCreateFontIndirect(dev->getDevice(),&LogFont,&font);

};
BSFont::~BSFont() {
	Release();
};

void BSFont::Release() {
	if (font != NULL) { font->Release(); font = NULL; }
};

/************** PROPERTIES ***************/

LONG BSFont::getSize() {
	return LogFont.Height;
};
string BSFont::getFontname() {
	return LogFont.FaceName;
};

/************** DRAW ***************/

void BSFont::draw() {}; //null draw to fullfil the requirement of the BSGUIObject

void BSFont::draw(string text, RECT* pos, BSCOLOUR colour) {
	//before using this function we have to use the bsgui begintext to
	//start drawing in the textsprite.
	//this function simply draw the text using the font properties and the parameters
	font->DrawText(getGUI()->getTextSprite(), text.c_str(),-1,pos,DT_NOCLIP,colour);
};