/*
  BSGUI
  This class will hold every GUI Object and the device to render
  it.
**/
#ifndef _BSGUI
#define _BSGUI
#include "bstypes.h"
#include "bsdevice.h"
#include "bsguicontainer.h"

class BSGUI : public BSGUIContainer {
	private:
		BSDevice* bsd;					// pointer to the device
		ID3DXSprite* textsprite;		// sprite for batching draw text calls
	public:
		BSGUI(BSDevice* dev) : BSGUIContainer() { bsd = dev; D3DXCreateSprite( bsd->getDevice(), &textsprite ); };
		~BSGUI() { Release(); };

		void Release();						//release all objects

		LPDIRECT3DDEVICE9 getDevice() { return bsd->getDevice(); }; //return the d3d device
		ID3DXSprite* getTextSprite() { return textsprite; }; //return the sprite to be used when drawing fonts

		void beginText();			//initialize the font sprite
		void endText();				//end the font sprite
		//void begin();				//start all sprites including the text
		//void end();				//start all sprites including the text

		void drawAll();

		//overriding Container methods to be public
		void addObject(BSGUIObject* obj) { BSGUIContainer::addObject(obj); } ;	//add a new gui object
		void removeObject(BSGUIObject* obj, BOOL destroy) { BSGUIContainer::removeObject(obj, destroy); };//remove a gui object
		BSGUIOBJ getListBegin() { return BSGUIContainer::getListBegin(); };
		BSGUIOBJ getListEnd() { return BSGUIContainer::getListEnd(); };
};
#endif
