/*
  BSGUIContainer
    Represent the ability to be a GUI container, being able to add and remove other components.
*/
#ifndef _BSGUICONTAINER
#define _BSGUICONTAINER
#include <list>
#include "bstypes.h"

using std::list;
using std::allocator;

class BSGUIObject;

typedef list< BSGUIObject*, allocator< BSGUIObject*> > BSGUIOBJECTLIST; //List of objects in the scene
typedef BSGUIOBJECTLIST::iterator BSGUIOBJ; //unsafe basic type of iterator object (to use with begin and end)

class BSGUIContainer {
	private:
		BSGUIOBJECTLIST list;
	protected: //override as public when needed (some objects may not want to their secrets be revealed)
		void addObject(BSGUIObject* obj);	//add a new gui object
		void removeObject(BSGUIObject* obj, BOOL destroy);//remove a gui object
		//unsafe search methods
		BSGUIOBJ getListBegin() { return list.begin(); };
		BSGUIOBJ getListEnd() { return list.end(); };
};
#endif