#include "bslabel.h"

/************** CONSTRUCTOR ***************/

BSLabel::BSLabel(BSGUIObject* parent, BSFont* f, string t, BSCOLOUR c) : BSGUIPosObject(f->getGUI(), parent) {
	ZeroMemory(&pos, sizeof(pos)); //cleaning pos
//	setParent(p);
	setText(t); //text
	setColour(c); //colour
	font = f;
};
BSLabel::~BSLabel() {
	Release();
};

void BSLabel::Release() {
	if (font != NULL) font->Release();
};

/************** PROPERTIES ***************/

void BSLabel::setText(string t) {
	text = t;
};


void BSLabel::setColour(BSCOLOUR c) {
	colour = c;
};

BSCOLOUR BSLabel::getColour() {
	return colour;
};

string BSLabel::getText() {
	return text;
};

/************* DRAW *******************/

void BSLabel::draw() {
	//get the font and the properties to draw the text
	font->draw(getText(), &getRect(), getColour());
};