/**
   BSLabel
     GUI labels to draw. It uses a pre created font.
**/
#ifndef _BSLABEL
#define _BSLABEL
#include "bsfont.h"
#include "bsguiposobject.h"

class BSLabel : public BSGUIPosObject {
	private:
		BSFont* font;					// font to be used

		BSCOLOUR colour;				// font colour
		RECT pos;						// rectangle to define the position (this must stay on BSText)
		string text;					// text to be draw
	public:
		BSLabel(BSGUIObject* parent, BSFont* f, string t, BSCOLOUR c);
		~BSLabel();

		void Release();

		//properties
		void setText(string t);					// change text
		void setColour(BSCOLOUR c);				// change colour
		void setFont(BSFont* f) { font = f; };	// redefine font
		BSFont* getFont() { return font; };		// return the font used
		BSCOLOUR BSLabel::getColour();			// get current colour
		string BSLabel::getText();				// get current text

		void draw();
};
#endif