#ifndef _BSSCENECONTAINER
#define _BSSCENECONTAINER
#include <list>
#include "bstypes.h"

using std::list;
using std::allocator;

class BSSceneObject;

typedef list< BSSceneObject*, allocator< BSSceneObject*> > BSSCENEOBJECTLIST; //List of objects in the scene
typedef BSSCENEOBJECTLIST::iterator BSSCENEOBJ; //unsafe basic type of iterator object (to use with begin and end)

class BSSceneContainer {
	private:
		BSSCENEOBJECTLIST list;
	protected: //override as public when needed (some objects may not want to their secrets be revealed)
		void addObject(BSSceneObject* obj);	//add a new Scene object
		void removeObject(BSSceneObject* obj, BOOL destroy);//remove a Scene object
		//unsafe search methods
		BSSCENEOBJ getListBegin() { return list.begin(); };
		BSSCENEOBJ getListEnd() { return list.end(); };
};
#endif