/**
  Engine Basic Types
*/

#ifndef _BSTYPES
#include <d3d9.h>
#include <d3dx9math.h>

//Setting BS types
typedef D3DCOLOR BSCOLOUR; //basic colour
#define KEYBOARD_ROTATION_SPEED 6	//define the rotation speed
#define KEYBOARD_ZOOM_SPEED 60 //define the zoom speed for the keyboard

//Easy Functions
#define BSToRadian(a) D3DXToRadian(a)
#define BSCOLOUR_RBG(r, g, b) D3DCOLOR_XRGB(r, g, b)

//Events

//struct to hold the keyboard event
struct KEYBOARDDETAIL {
	BYTE key[256];
};

//struct to hold the mouse events
struct MOUSEDETAIL {
	LONG x, y, z;
	BYTE bnt[4];
};
//struct to hold the scene object position
typedef struct BSPOS
{			
	BSPOS() {}	// constructor
	BSPOS (FLOAT new_x, FLOAT new_y, FLOAT new_z) // initialize constructor	 
	{x = new_x; y = new_y; z = new_z;}
	BSPOS operator+(BSPOS vVector) {return BSPOS(vVector.x+x, vVector.y+y, vVector.z+z);} //add vectors
	BSPOS operator-(BSPOS vVector) {return BSPOS(x-vVector.x, y-vVector.y, z-vVector.z);} //subtract vectors
	BSPOS operator*(float number)	 {return BSPOS(x*number, y*number, z*number);} //multiply scalars
	BSPOS operator/(float number)	 {return BSPOS(x/number, y/number, z/number);} //divide scalars
	
	FLOAT x, y, z;						//coordinates
}BSPOS;

//converting pos to vector
D3DXVECTOR3  BSToVector3(BSPOS pos) ;

typedef void(*MOUSEEVENT)(const MOUSEDETAIL); //Mouse Event Function Prototype
typedef void(*KEYBOARDEVENT)(const KEYBOARDDETAIL); //KeyBoard Event Function Prototype

#define _BSTYPES
#endif //_BSTYPES


/*
  I was thinking about create every single type as BS but in 
  the end I felt that would make the things even more confunsing. 
  I think there is no problem sometimes a DirectX interface shows up
  (as in the getDevice of BSDevice)

typedef LPD3DXFONT BSDXFONT; //directx font
typedef LPDIRECT3DDEVICE9 BSDXDEV; //our DirectX Device
typedef LPDIRECT3D9 BSDXINTERFACE; // our Direct3D interface
typedef D3DPRESENT_PARAMETERS BSDXDEVSTRUCT;// create a struct to hold various device information
typedef LPDIRECTINPUT8 BSDXINPUT;// our DirectInput interface
typedef LPDIRECTINPUTDEVICE8 BSDXINPUTDEV;   //our DirectInput Device
*/
